// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from nao_sensor_msgs:msg/Buttons.idl
// generated code does not contain a copyright notice
#include "nao_sensor_msgs/msg/detail/buttons__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


bool
nao_sensor_msgs__msg__Buttons__init(nao_sensor_msgs__msg__Buttons * msg)
{
  if (!msg) {
    return false;
  }
  // chest
  // l_foot_bumper_left
  // l_foot_bumper_right
  // r_foot_bumper_left
  // r_foot_bumper_right
  return true;
}

void
nao_sensor_msgs__msg__Buttons__fini(nao_sensor_msgs__msg__Buttons * msg)
{
  if (!msg) {
    return;
  }
  // chest
  // l_foot_bumper_left
  // l_foot_bumper_right
  // r_foot_bumper_left
  // r_foot_bumper_right
}

bool
nao_sensor_msgs__msg__Buttons__are_equal(const nao_sensor_msgs__msg__Buttons * lhs, const nao_sensor_msgs__msg__Buttons * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // chest
  if (lhs->chest != rhs->chest) {
    return false;
  }
  // l_foot_bumper_left
  if (lhs->l_foot_bumper_left != rhs->l_foot_bumper_left) {
    return false;
  }
  // l_foot_bumper_right
  if (lhs->l_foot_bumper_right != rhs->l_foot_bumper_right) {
    return false;
  }
  // r_foot_bumper_left
  if (lhs->r_foot_bumper_left != rhs->r_foot_bumper_left) {
    return false;
  }
  // r_foot_bumper_right
  if (lhs->r_foot_bumper_right != rhs->r_foot_bumper_right) {
    return false;
  }
  return true;
}

bool
nao_sensor_msgs__msg__Buttons__copy(
  const nao_sensor_msgs__msg__Buttons * input,
  nao_sensor_msgs__msg__Buttons * output)
{
  if (!input || !output) {
    return false;
  }
  // chest
  output->chest = input->chest;
  // l_foot_bumper_left
  output->l_foot_bumper_left = input->l_foot_bumper_left;
  // l_foot_bumper_right
  output->l_foot_bumper_right = input->l_foot_bumper_right;
  // r_foot_bumper_left
  output->r_foot_bumper_left = input->r_foot_bumper_left;
  // r_foot_bumper_right
  output->r_foot_bumper_right = input->r_foot_bumper_right;
  return true;
}

nao_sensor_msgs__msg__Buttons *
nao_sensor_msgs__msg__Buttons__create()
{
  nao_sensor_msgs__msg__Buttons * msg = (nao_sensor_msgs__msg__Buttons *)malloc(sizeof(nao_sensor_msgs__msg__Buttons));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(nao_sensor_msgs__msg__Buttons));
  bool success = nao_sensor_msgs__msg__Buttons__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
nao_sensor_msgs__msg__Buttons__destroy(nao_sensor_msgs__msg__Buttons * msg)
{
  if (msg) {
    nao_sensor_msgs__msg__Buttons__fini(msg);
  }
  free(msg);
}


bool
nao_sensor_msgs__msg__Buttons__Sequence__init(nao_sensor_msgs__msg__Buttons__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  nao_sensor_msgs__msg__Buttons * data = NULL;
  if (size) {
    data = (nao_sensor_msgs__msg__Buttons *)calloc(size, sizeof(nao_sensor_msgs__msg__Buttons));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = nao_sensor_msgs__msg__Buttons__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        nao_sensor_msgs__msg__Buttons__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
nao_sensor_msgs__msg__Buttons__Sequence__fini(nao_sensor_msgs__msg__Buttons__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      nao_sensor_msgs__msg__Buttons__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

nao_sensor_msgs__msg__Buttons__Sequence *
nao_sensor_msgs__msg__Buttons__Sequence__create(size_t size)
{
  nao_sensor_msgs__msg__Buttons__Sequence * array = (nao_sensor_msgs__msg__Buttons__Sequence *)malloc(sizeof(nao_sensor_msgs__msg__Buttons__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = nao_sensor_msgs__msg__Buttons__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
nao_sensor_msgs__msg__Buttons__Sequence__destroy(nao_sensor_msgs__msg__Buttons__Sequence * array)
{
  if (array) {
    nao_sensor_msgs__msg__Buttons__Sequence__fini(array);
  }
  free(array);
}

bool
nao_sensor_msgs__msg__Buttons__Sequence__are_equal(const nao_sensor_msgs__msg__Buttons__Sequence * lhs, const nao_sensor_msgs__msg__Buttons__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!nao_sensor_msgs__msg__Buttons__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
nao_sensor_msgs__msg__Buttons__Sequence__copy(
  const nao_sensor_msgs__msg__Buttons__Sequence * input,
  nao_sensor_msgs__msg__Buttons__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(nao_sensor_msgs__msg__Buttons);
    nao_sensor_msgs__msg__Buttons * data =
      (nao_sensor_msgs__msg__Buttons *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!nao_sensor_msgs__msg__Buttons__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          nao_sensor_msgs__msg__Buttons__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!nao_sensor_msgs__msg__Buttons__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
