// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from nao_sensor_msgs:msg/JointIndexes.idl
// generated code does not contain a copyright notice
#include "nao_sensor_msgs/msg/detail/joint_indexes__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


bool
nao_sensor_msgs__msg__JointIndexes__init(nao_sensor_msgs__msg__JointIndexes * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
nao_sensor_msgs__msg__JointIndexes__fini(nao_sensor_msgs__msg__JointIndexes * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bool
nao_sensor_msgs__msg__JointIndexes__are_equal(const nao_sensor_msgs__msg__JointIndexes * lhs, const nao_sensor_msgs__msg__JointIndexes * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // structure_needs_at_least_one_member
  if (lhs->structure_needs_at_least_one_member != rhs->structure_needs_at_least_one_member) {
    return false;
  }
  return true;
}

bool
nao_sensor_msgs__msg__JointIndexes__copy(
  const nao_sensor_msgs__msg__JointIndexes * input,
  nao_sensor_msgs__msg__JointIndexes * output)
{
  if (!input || !output) {
    return false;
  }
  // structure_needs_at_least_one_member
  output->structure_needs_at_least_one_member = input->structure_needs_at_least_one_member;
  return true;
}

nao_sensor_msgs__msg__JointIndexes *
nao_sensor_msgs__msg__JointIndexes__create()
{
  nao_sensor_msgs__msg__JointIndexes * msg = (nao_sensor_msgs__msg__JointIndexes *)malloc(sizeof(nao_sensor_msgs__msg__JointIndexes));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(nao_sensor_msgs__msg__JointIndexes));
  bool success = nao_sensor_msgs__msg__JointIndexes__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
nao_sensor_msgs__msg__JointIndexes__destroy(nao_sensor_msgs__msg__JointIndexes * msg)
{
  if (msg) {
    nao_sensor_msgs__msg__JointIndexes__fini(msg);
  }
  free(msg);
}


bool
nao_sensor_msgs__msg__JointIndexes__Sequence__init(nao_sensor_msgs__msg__JointIndexes__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  nao_sensor_msgs__msg__JointIndexes * data = NULL;
  if (size) {
    data = (nao_sensor_msgs__msg__JointIndexes *)calloc(size, sizeof(nao_sensor_msgs__msg__JointIndexes));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = nao_sensor_msgs__msg__JointIndexes__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        nao_sensor_msgs__msg__JointIndexes__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
nao_sensor_msgs__msg__JointIndexes__Sequence__fini(nao_sensor_msgs__msg__JointIndexes__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      nao_sensor_msgs__msg__JointIndexes__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

nao_sensor_msgs__msg__JointIndexes__Sequence *
nao_sensor_msgs__msg__JointIndexes__Sequence__create(size_t size)
{
  nao_sensor_msgs__msg__JointIndexes__Sequence * array = (nao_sensor_msgs__msg__JointIndexes__Sequence *)malloc(sizeof(nao_sensor_msgs__msg__JointIndexes__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = nao_sensor_msgs__msg__JointIndexes__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
nao_sensor_msgs__msg__JointIndexes__Sequence__destroy(nao_sensor_msgs__msg__JointIndexes__Sequence * array)
{
  if (array) {
    nao_sensor_msgs__msg__JointIndexes__Sequence__fini(array);
  }
  free(array);
}

bool
nao_sensor_msgs__msg__JointIndexes__Sequence__are_equal(const nao_sensor_msgs__msg__JointIndexes__Sequence * lhs, const nao_sensor_msgs__msg__JointIndexes__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!nao_sensor_msgs__msg__JointIndexes__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
nao_sensor_msgs__msg__JointIndexes__Sequence__copy(
  const nao_sensor_msgs__msg__JointIndexes__Sequence * input,
  nao_sensor_msgs__msg__JointIndexes__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(nao_sensor_msgs__msg__JointIndexes);
    nao_sensor_msgs__msg__JointIndexes * data =
      (nao_sensor_msgs__msg__JointIndexes *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!nao_sensor_msgs__msg__JointIndexes__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          nao_sensor_msgs__msg__JointIndexes__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!nao_sensor_msgs__msg__JointIndexes__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
