// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from nao_sensor_msgs:msg/JointStiffnesses.idl
// generated code does not contain a copyright notice
#include "nao_sensor_msgs/msg/detail/joint_stiffnesses__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


bool
nao_sensor_msgs__msg__JointStiffnesses__init(nao_sensor_msgs__msg__JointStiffnesses * msg)
{
  if (!msg) {
    return false;
  }
  // stiffnesses
  return true;
}

void
nao_sensor_msgs__msg__JointStiffnesses__fini(nao_sensor_msgs__msg__JointStiffnesses * msg)
{
  if (!msg) {
    return;
  }
  // stiffnesses
}

bool
nao_sensor_msgs__msg__JointStiffnesses__are_equal(const nao_sensor_msgs__msg__JointStiffnesses * lhs, const nao_sensor_msgs__msg__JointStiffnesses * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // stiffnesses
  for (size_t i = 0; i < 25; ++i) {
    if (lhs->stiffnesses[i] != rhs->stiffnesses[i]) {
      return false;
    }
  }
  return true;
}

bool
nao_sensor_msgs__msg__JointStiffnesses__copy(
  const nao_sensor_msgs__msg__JointStiffnesses * input,
  nao_sensor_msgs__msg__JointStiffnesses * output)
{
  if (!input || !output) {
    return false;
  }
  // stiffnesses
  for (size_t i = 0; i < 25; ++i) {
    output->stiffnesses[i] = input->stiffnesses[i];
  }
  return true;
}

nao_sensor_msgs__msg__JointStiffnesses *
nao_sensor_msgs__msg__JointStiffnesses__create()
{
  nao_sensor_msgs__msg__JointStiffnesses * msg = (nao_sensor_msgs__msg__JointStiffnesses *)malloc(sizeof(nao_sensor_msgs__msg__JointStiffnesses));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(nao_sensor_msgs__msg__JointStiffnesses));
  bool success = nao_sensor_msgs__msg__JointStiffnesses__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
nao_sensor_msgs__msg__JointStiffnesses__destroy(nao_sensor_msgs__msg__JointStiffnesses * msg)
{
  if (msg) {
    nao_sensor_msgs__msg__JointStiffnesses__fini(msg);
  }
  free(msg);
}


bool
nao_sensor_msgs__msg__JointStiffnesses__Sequence__init(nao_sensor_msgs__msg__JointStiffnesses__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  nao_sensor_msgs__msg__JointStiffnesses * data = NULL;
  if (size) {
    data = (nao_sensor_msgs__msg__JointStiffnesses *)calloc(size, sizeof(nao_sensor_msgs__msg__JointStiffnesses));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = nao_sensor_msgs__msg__JointStiffnesses__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        nao_sensor_msgs__msg__JointStiffnesses__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
nao_sensor_msgs__msg__JointStiffnesses__Sequence__fini(nao_sensor_msgs__msg__JointStiffnesses__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      nao_sensor_msgs__msg__JointStiffnesses__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

nao_sensor_msgs__msg__JointStiffnesses__Sequence *
nao_sensor_msgs__msg__JointStiffnesses__Sequence__create(size_t size)
{
  nao_sensor_msgs__msg__JointStiffnesses__Sequence * array = (nao_sensor_msgs__msg__JointStiffnesses__Sequence *)malloc(sizeof(nao_sensor_msgs__msg__JointStiffnesses__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = nao_sensor_msgs__msg__JointStiffnesses__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
nao_sensor_msgs__msg__JointStiffnesses__Sequence__destroy(nao_sensor_msgs__msg__JointStiffnesses__Sequence * array)
{
  if (array) {
    nao_sensor_msgs__msg__JointStiffnesses__Sequence__fini(array);
  }
  free(array);
}

bool
nao_sensor_msgs__msg__JointStiffnesses__Sequence__are_equal(const nao_sensor_msgs__msg__JointStiffnesses__Sequence * lhs, const nao_sensor_msgs__msg__JointStiffnesses__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!nao_sensor_msgs__msg__JointStiffnesses__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
nao_sensor_msgs__msg__JointStiffnesses__Sequence__copy(
  const nao_sensor_msgs__msg__JointStiffnesses__Sequence * input,
  nao_sensor_msgs__msg__JointStiffnesses__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(nao_sensor_msgs__msg__JointStiffnesses);
    nao_sensor_msgs__msg__JointStiffnesses * data =
      (nao_sensor_msgs__msg__JointStiffnesses *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!nao_sensor_msgs__msg__JointStiffnesses__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          nao_sensor_msgs__msg__JointStiffnesses__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!nao_sensor_msgs__msg__JointStiffnesses__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
