// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from nao_sensor_msgs:msg/RobotConfig.idl
// generated code does not contain a copyright notice
#include "nao_sensor_msgs/msg/detail/robot_config__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `body_id`
// Member `body_version`
// Member `head_id`
// Member `head_version`
#include "rosidl_runtime_c/string_functions.h"

bool
nao_sensor_msgs__msg__RobotConfig__init(nao_sensor_msgs__msg__RobotConfig * msg)
{
  if (!msg) {
    return false;
  }
  // body_id
  if (!rosidl_runtime_c__String__init(&msg->body_id)) {
    nao_sensor_msgs__msg__RobotConfig__fini(msg);
    return false;
  }
  // body_version
  if (!rosidl_runtime_c__String__init(&msg->body_version)) {
    nao_sensor_msgs__msg__RobotConfig__fini(msg);
    return false;
  }
  // head_id
  if (!rosidl_runtime_c__String__init(&msg->head_id)) {
    nao_sensor_msgs__msg__RobotConfig__fini(msg);
    return false;
  }
  // head_version
  if (!rosidl_runtime_c__String__init(&msg->head_version)) {
    nao_sensor_msgs__msg__RobotConfig__fini(msg);
    return false;
  }
  return true;
}

void
nao_sensor_msgs__msg__RobotConfig__fini(nao_sensor_msgs__msg__RobotConfig * msg)
{
  if (!msg) {
    return;
  }
  // body_id
  rosidl_runtime_c__String__fini(&msg->body_id);
  // body_version
  rosidl_runtime_c__String__fini(&msg->body_version);
  // head_id
  rosidl_runtime_c__String__fini(&msg->head_id);
  // head_version
  rosidl_runtime_c__String__fini(&msg->head_version);
}

bool
nao_sensor_msgs__msg__RobotConfig__are_equal(const nao_sensor_msgs__msg__RobotConfig * lhs, const nao_sensor_msgs__msg__RobotConfig * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // body_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->body_id), &(rhs->body_id)))
  {
    return false;
  }
  // body_version
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->body_version), &(rhs->body_version)))
  {
    return false;
  }
  // head_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->head_id), &(rhs->head_id)))
  {
    return false;
  }
  // head_version
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->head_version), &(rhs->head_version)))
  {
    return false;
  }
  return true;
}

bool
nao_sensor_msgs__msg__RobotConfig__copy(
  const nao_sensor_msgs__msg__RobotConfig * input,
  nao_sensor_msgs__msg__RobotConfig * output)
{
  if (!input || !output) {
    return false;
  }
  // body_id
  if (!rosidl_runtime_c__String__copy(
      &(input->body_id), &(output->body_id)))
  {
    return false;
  }
  // body_version
  if (!rosidl_runtime_c__String__copy(
      &(input->body_version), &(output->body_version)))
  {
    return false;
  }
  // head_id
  if (!rosidl_runtime_c__String__copy(
      &(input->head_id), &(output->head_id)))
  {
    return false;
  }
  // head_version
  if (!rosidl_runtime_c__String__copy(
      &(input->head_version), &(output->head_version)))
  {
    return false;
  }
  return true;
}

nao_sensor_msgs__msg__RobotConfig *
nao_sensor_msgs__msg__RobotConfig__create()
{
  nao_sensor_msgs__msg__RobotConfig * msg = (nao_sensor_msgs__msg__RobotConfig *)malloc(sizeof(nao_sensor_msgs__msg__RobotConfig));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(nao_sensor_msgs__msg__RobotConfig));
  bool success = nao_sensor_msgs__msg__RobotConfig__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
nao_sensor_msgs__msg__RobotConfig__destroy(nao_sensor_msgs__msg__RobotConfig * msg)
{
  if (msg) {
    nao_sensor_msgs__msg__RobotConfig__fini(msg);
  }
  free(msg);
}


bool
nao_sensor_msgs__msg__RobotConfig__Sequence__init(nao_sensor_msgs__msg__RobotConfig__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  nao_sensor_msgs__msg__RobotConfig * data = NULL;
  if (size) {
    data = (nao_sensor_msgs__msg__RobotConfig *)calloc(size, sizeof(nao_sensor_msgs__msg__RobotConfig));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = nao_sensor_msgs__msg__RobotConfig__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        nao_sensor_msgs__msg__RobotConfig__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
nao_sensor_msgs__msg__RobotConfig__Sequence__fini(nao_sensor_msgs__msg__RobotConfig__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      nao_sensor_msgs__msg__RobotConfig__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

nao_sensor_msgs__msg__RobotConfig__Sequence *
nao_sensor_msgs__msg__RobotConfig__Sequence__create(size_t size)
{
  nao_sensor_msgs__msg__RobotConfig__Sequence * array = (nao_sensor_msgs__msg__RobotConfig__Sequence *)malloc(sizeof(nao_sensor_msgs__msg__RobotConfig__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = nao_sensor_msgs__msg__RobotConfig__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
nao_sensor_msgs__msg__RobotConfig__Sequence__destroy(nao_sensor_msgs__msg__RobotConfig__Sequence * array)
{
  if (array) {
    nao_sensor_msgs__msg__RobotConfig__Sequence__fini(array);
  }
  free(array);
}

bool
nao_sensor_msgs__msg__RobotConfig__Sequence__are_equal(const nao_sensor_msgs__msg__RobotConfig__Sequence * lhs, const nao_sensor_msgs__msg__RobotConfig__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!nao_sensor_msgs__msg__RobotConfig__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
nao_sensor_msgs__msg__RobotConfig__Sequence__copy(
  const nao_sensor_msgs__msg__RobotConfig__Sequence * input,
  nao_sensor_msgs__msg__RobotConfig__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(nao_sensor_msgs__msg__RobotConfig);
    nao_sensor_msgs__msg__RobotConfig * data =
      (nao_sensor_msgs__msg__RobotConfig *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!nao_sensor_msgs__msg__RobotConfig__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          nao_sensor_msgs__msg__RobotConfig__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!nao_sensor_msgs__msg__RobotConfig__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
